import SharedElementSceneData, { SharedElementSceneEventType } from './SharedElementSceneData';
import { SharedElementEventSubscription, SharedElementTransitionProps, SharedElementRoute } from './types';
export declare type SharedElementRendererUpdateHandler = () => any;
export interface ISharedElementRendererData {
    startTransition(closing: boolean, navigatorId: string, nestingDepth: number): void;
    endTransition(closing: boolean, navigatorId: string, nestingDepth: number): void;
    updateSceneState(sceneData: SharedElementSceneData, route: SharedElementRoute, sceneEvent: SharedElementSceneEventType): void;
    readonly nestingDepth: number;
}
/**
 * TODO
 *
 * - [X] Start animation on `startTransition`
 * - [X] Use animValue from started navigator
 * - [X] Use route from deepest nested scene
 * - [X] Support nesting
 * - [ ] Not all lifecycle events not emitted by stack when using gestures (close modal)
 */
export default class SharedElementRendererData implements ISharedElementRendererData {
    private scenes;
    private updateSubscribers;
    private sharedElements;
    private isShowing;
    private route;
    private prevRoute;
    private routeAnimValue?;
    private scene;
    private prevScene;
    private sceneAnimValue?;
    private isTransitionStarted;
    private isTransitionClosing;
    private transitionNavigatorId;
    private transitionNestingDepth;
    private isVerbose;
    startTransition(closing: boolean, navigatorId: string, nestingDepth: number): void;
    endTransition(closing: boolean, navigatorId: string, nestingDepth: number): void;
    updateSceneState(sceneData: SharedElementSceneData, route: SharedElementRoute, sceneEvent: SharedElementSceneEventType): void;
    willFocusScene(sceneData: SharedElementSceneData, route: SharedElementRoute): void;
    didFocusScene(sceneData: SharedElementSceneData, route: SharedElementRoute): void;
    willBlurScene(sceneData: SharedElementSceneData, route: SharedElementRoute): void;
    private registerScene;
    private updateSceneListeners;
    private getScene;
    private updateSharedElements;
    addUpdateListener(handler: SharedElementRendererUpdateHandler): SharedElementEventSubscription;
    private emitUpdateEvent;
    getTransitions(): SharedElementTransitionProps[];
    get nestingDepth(): number;
}
